'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buildInterface;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

var _buildFieldConfigMap = require('./buildFieldConfigMap');

var _buildFieldConfigMap2 = _interopRequireDefault(_buildFieldConfigMap);

var _resolveShortcut = require('./resolveShortcut');

var _resolveShortcut2 = _interopRequireDefault(_resolveShortcut);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildInterface(interfaceAST, config = {}, types) {
  const interfaceTypeConfig = { name: interfaceAST.name.value };
  const description = (0, _buildASTSchema.getDescription)(interfaceAST);
  if (!('fields' in config) && !('resolveType' in config)) {
    // `resolve` shortcut
    interfaceTypeConfig.fields = () => (0, _buildFieldConfigMap2.default)(interfaceAST, (0, _resolveShortcut2.default)(config), types);
  } else {
    interfaceTypeConfig.fields = () => (0, _buildFieldConfigMap2.default)(interfaceAST, config.fields, types);
    interfaceTypeConfig.resolveType = config.resolveType;
  }
  if (description) interfaceTypeConfig.description = description;
  return new _type.GraphQLInterfaceType(interfaceTypeConfig);
}