'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildOperation = undefined;
exports.default = buildSchema;

var _type = require('graphql/type');

var _produceType = require('./produceType');

var _produceType2 = _interopRequireDefault(_produceType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const buildOperation = exports.buildOperation = (schemaAST, operation, types) => {
  const operationAST = schemaAST.operationTypes.find(ast => ast.operation === operation);
  return operationAST && (0, _produceType2.default)(operationAST.type, types);
};

function buildSchema(schemaAST, { types, directives } = {}, typeDeps) {
  const query = buildOperation(schemaAST, 'query', typeDeps);
  const mutation = buildOperation(schemaAST, 'mutation', typeDeps);
  const subscription = buildOperation(schemaAST, 'subscription', typeDeps);
  const schemaConfig = { types, directives };
  if (query) schemaConfig.query = query;
  if (mutation) schemaConfig.mutation = mutation;
  if (subscription) schemaConfig.subscription = subscription;
  return new _type.GraphQLSchema(schemaConfig);
}